":";exec java -cp $HOME/roBin/src:$HOME/roBin/lib/* clojure.main $0 $*; 

(ns rlm.kitchen-mailer
  "This program runs every day as a cron job to remind people
   to clean the tetazoo kitchen.  Everyone with a cabinet must
   clean the kitchen."
  {:author "Robert McIntyre"}
  (:use [com.draines.postal [core :only [send-message]]]
	[rlm [shell-inspect :only [command-line?]]])
  (:import [org.joda.time Days DateMidnight]))

(defn start-day [] (DateMidnight. 2011 2 13))

(def cabinets
     [["deborahc"]
      ["maponte"]
      ["k_french"] 
      ["clarkds"]
      ["kharring"]
      ["jasminef"]
      ["kerrynic"]
      ["guertin"]
      ["ervanalb"]
      ["tayral13"]
      ["rbowru"]
      ["lexrj"]
      ["viccro"]
      ["kfish"]
      ["k8r" "infrared"]
      ["verdant"]
      ["greener"]
      ["phulin"]
      ["slehmann"]
      ["acrefoot"]
      ["oliviame"]])

(def kitchen-reminder
  {:from "kitchen-bitch-bot@rlmcintyre.com"
   :cc [ "rlm@mit.edu"  "slehmann@mit.edu" ]
   :subject "It's your turn to clean the kitchen"
   :body  "
    It's your day to clean the kitchen.
    If it isn't clean by 23:00, I will not hesitate to
    hunt you down/wake you up/pry you away from your p-set.

         <3, Kitchen Bitch

    --------------------------------------------
    This mailer is open source and all that; you can see the source at
    http://www.rlmcintyre.com/kitchen-bitch.txt"})
     
(defn get-current-date []  (DateMidnight.))

(defn days-since-start-day [start-day end-day]
  (.getDays (Days/daysBetween start-day end-day)))

(defn mail-a-tetazoan
  "tetazoan will be a username like kfish, with the \"@mit.edu\" implied."
  [tetazoan message]
  (if-not (nil? tetazoan)
    (let [message (merge message {:to (into [] (map #(str % "@mit.edu") tetazoan))})]
      (println message)
      (send-message message))))
       
(defn target-person []
  (cabinets
   (rem (days-since-start-day (start-day) (get-current-date))
	(count cabinets))))

(defn main []
  (println "mailing " (target-person)) 
;;  (println (mail-a-tetazoan (target-person) kitchen-reminder))
  )

(if (command-line?) (main))
