(ns rlm.mike)

(defmacro define [name e]
  (if (symbol? name)
    `(def ~name ~e)
    `(define ~(first name) (fn [~@(rest name)] (~@e)))))

(defmacro lambda [a b]
  `(fn [~@a] ~b)) 

(defmacro with-quote-everything [form]
  (let [prime (first form)
	rests (rest form)
	rests (map (fn [form] `(quote ~form)) rests)
	]
    `(~prime ~@rests)))

(defn mike-define [name e]
  (if (symbol? name)
    (intern *ns*  name e)
    (mike-define (first name) '(lambda (rest name) e ))))
      
(defn Y
  "The y-combinator"
  [m]
  ((fn [future]
     (m (fn [arg]
	  ((future future) arg))))
   (fn [future]                       ;;this reminds me a lot of a quine!
     (m (fn [arg]
	  ((future future) arg)))) ))


(defn factorial [n]
  (if (zero? n)
    1
    (* n (factorial (dec n)))) )

((Y (fn [rec]
      (fn [n]
	(if (zero? n)
	  1
	  (* n (rec (dec n)))) ))) 6) 
