":";exec java -verbose:gc -Xmn500M -Xms1500M -Xmx1500M -server -cp $HOME/roBin/src:$HOME/mobius/src:$HOME/roBin/lib/*:$HOME/Genesis/src:$HOME/mobius/assets:$HOME/mobius/monkey-lib/*:$HOME/workspace/Gauntlet/binary:$HOME/workspace/Clips/bin:$HOME/workspace/Propagators/bin  -Djava.library.path=$HOME/roBin/natives/linux   clojure.main $0 $*;



(ns rlm.push
(:gen-class
 :name rlm.push
 :main true)
(:use [clojure.contrib
       [duck-streams :only [file-str]]
       command-line str-utils shell-out]
      [rlm shell-write
       [shell-inspect :only [command-line?]]]))


(def laserkard ["/home/r/Desktop/web/laserkard"
		"/home/r/lasercutter"
		"/home/r/laser-files"
		"/home/r/emc2"])

(def moonlitnights ["/home/r/Desktop/web/moonlitnights"])

(def judyates ["/home/r/Desktop/web/judyates"])

(def rlmcintyre ["/home/r/Desktop/web/rlmcintyre",
		 "/home/r/Desktop/web/boosterpack"
		 "/home/r/Desktop/web/lib"])

(def bortreb ["/home/r/Desktop/web/bortreb"])

(def aurellem ["/home/r/aurellem/site-output"])

(def mit ["/home/r/Desktop/MIT"])
	 

(def config
     ["/home/r/.swank-all-repl"
      "/home/r/.clojure_completions"
      "/home/r/swank-all"
      "/home/r/Desktop/web/web.clj"
      "/etc/lighttpd/lighttpd.conf"
      "/home/r/.lightpasswords"
      "/home/r/.profile"
      "/home/r/.xmodmap.clojure"
      "/home/r/.xmodmap.xmonad"
      "/home/r/.xmodmap.normal"
      "/etc/hosts"
      "/home/r/Desktop/web/swank-web"
      "/etc/mercurial/hgrc"
      "/home/r/.hgrc"
      "/home/r/.emacs"
      "/home/r/.emacs.d"
      "/home/r/.bashrc"
      "/home/r/.el"
       "/home/r/.blender"
      ])


(def admin
     ["/home/r/Desktop/sliceHost_Admin"
      "/home/r/Desktop/judyates_admin"
      "/home/r/Desktop/laserkard_admin"
      "/home/r/Desktop/moonlitnights_admin"])

(def genesis
     [;;"/home/r/Desktop/GenesisOutput"
      "/home/r/Jake2"
      ;;"/home/r/workspace" --- removed because it interferes with eclipse's
      ;; color settings.  Stupid eclipse.
      "/home/r/Genesis"
      ;;"/home/r/eclipse" --- also interfers with eclipse's stupid colors.
      ;;"/home/r/telmo"
      ;;"/home/r/sajit"
      ])

(def projects
     ["/home/r/aurellem"
      "/home/r/cortex"
      "/home/r/mobius"
      "/home/r/roBin"
      "/home/r/openal-soft"
      "/home/r/Desktop/web"])

(defn rsync-string [#^java.io.File file]
  (if (.isFile file) 
    (.getPath file)
    (str (.getPath file) "/")))


(defn rsync-one [destination #^java.io.File file]
  (let 
      [command
       ["rsync" "-avzhO" "--delete" "--relative" (str "/." (rsync-string file)) destination ]]
    (println command)
    ;(apply sw command)
    command
    ))


(defn rsync [destination args]
  (doall (map (partial rsync-one destination)  (map file-str args))))
    
(def destinations {"slice" "r@173.203.202.72:/"
		   "rlm" "r@10.0.0.2:/"
		   "sphere" "/home/r/sphere" 
		   })



(defn push-gen [& args]
  (with-command-line args 
    "Push Files from this Computer to others."
    [[all? a?  "Update everything. (except genesis and admin)" false]
     [l? laserkard?  "laserkard source" false]
     [m? moonlitnights? "moonlitnights source" false]
     [j? judyates?  "judyates source" false]
     [r? rlmcintyre?  "rlmcintyre source" false]
     [b? bortreb?  "bortreb repository source" false]
     [c? config?  "webserver config files" false]
     [d? admin?  "website admin folders" false]
     [g? genesis?  "genesis" false]
     [p? projects?  "roBin, aurellem, mobius" false]
     [e? everything? "absolutely everything" false]
     [k? mit? "MIT" false]
     [u? aurellem? "aurellem SITE"]
     [target t
      (str "Target computer. mappings are " destinations " or any ipv4 ip address")
      "rlm"]]

    (if e? (into (push-gen "-g" "-d" "-k" "-t" target) (push-gen "-a" "-t" target))
	(if all?
	  (push-gen "-l" "-m" "-j" "-r" "-b" "-c" "-p" "-u" "-t" target)
	  (let [target (get destinations target (str "r@" target ":/"))]

	    (map (partial str-join " ")
	    (reduce into
	    (filter
	     (comp not nil?)
	     [
	      (if u? (rsync target aurellem) nil)
	      (if k? (rsync target mit) nil)
	      (if l? (rsync target laserkard) nil)
	      (if m? (rsync target moonlitnights) nil)
	      (if j? (rsync target judyates) nil)
	      (if r? (rsync target rlmcintyre) nil)
	      (if b? (rsync target bortreb) nil)
	      (if c? (rsync target config) nil)
	      (if d? (rsync target admin) nil)
	      (if g? (rsync target genesis) nil)
	      (if p? (rsync target projects) nil)]))))))))

(defn push [& args]
  (let [commands (apply push-gen args)]
    (if (not (nil? commands))
      (dorun (map sw commands)))))

(if (command-line?)
  (apply push *command-line-args*))


