(ns rlm.resistors
(:use [clojure.contrib [accumulators :only [combine] ]])
(:use [incanter core stats charts]))

(def value 1)

(defn parrallel [r1 r2]
  (/ 1 (+ ( / 1 r1) ( / 1 r2))))

(defn series [r1 r2]
  (+ r1 r2))

(defn total-nums [num-resistors]
  (if (= 1 num-resistors) #{value}
      (combine
       (apply hash-set (map (partial parrallel value) (total-nums (dec num-resistors))))
       (apply hash-set (map (partial series value) (total-nums (dec num-resistors))))
       (total-nums (dec num-resistors))
       )))

(def total-nums (memoize total-nums))
      
(defn spectrum [num] 
  (apply sorted-set (map float (total-nums num))))

(defn oh-yeah []
 (view (dynamic-scatter-plot [number (range 1 13 1)]
				   (let [vvv (apply vector (rlm.resistors/spectrum number))]
				   [(map identity vvv)
				     (repeat (count vvv) 0)])
				    :title "Resistor Combination Distribution")))
